unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Quit1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Lblocks: TLabel;
    Label5: TLabel;
    Lsectors: TLabel;
    Label6: TLabel;
    ComboBox3: TComboBox;
    Label7: TLabel;
    Lpages: TLabel;
    Lresblocks: TLabel;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    ListBox1: TListBox;
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label9: TLabel;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    LFree: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    ClearImage: TButton;
    ExportImage: TButton;
    Label11: TLabel;
    eNandTime: TEdit;
    emptyBoot: TRadioButton;
    SaveDialog1: TSaveDialog;
    bootFile: TRadioButton;
    imgfilename: TEdit;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    isNand: TRadioButton;
    isSPI: TRadioButton;
    Help1: TMenuItem;
    About1: TMenuItem;
    bootSP_SPI: TRadioButton;
    bootSP_NAND: TRadioButton;
    Label4: TLabel;
    fatSectors: TLabel;
    Area: TLabel;
    Label8: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Override16k: TCheckBox;
    ManualFatStartSector: TEdit;
    AddAll: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure ClearImageClick(Sender: TObject);
    procedure ExportImageClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure isSPIClick(Sender: TObject);
    procedure isNandClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure bootSP_SPIClick(Sender: TObject);
    procedure bootSP_NANDClick(Sender: TObject);
    procedure Override16kClick(Sender: TObject);
    procedure AddAllClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  ImgDataRecord = record

  identTag: Integer;
  nandType, dataBits, blockBits : Integer;
  totalSectors, blockSize, totalBlocks, pageSize, totalPages: Integer;
  reservedBlocksAtEnd: Integer;
  diskStartSector, fatStartSector, dataStartSector, fatSectors: Integer;
  rootSectors, dataSectors, freeSectors, reservedSectorsAtEnd: Integer;
  nextFreeSector: Integer;

  end;

  DiskSector = array[0..16383] of byte;

  DirectoryEntry = record
  Name      : array [0..7] of char;
  Ext       : array [0..2] of char;
  Attribute : byte;
  NTRes     : byte;
  TTenthSec : byte;
  CreatTime : word;
  CreatDate : word;
  AccesDate : word;
  ClusterHi : word;
  WriteTime : word;
  WriteDate : word;
  ClusterLo : word;
  FileSize  : longint;
  end;

const DIRECTORYENTRIES=10000;

var
  Form1: TForm1;
  img: ImgDataRecord;
  dir: array[0..DIRECTORYENTRIES] of DirectoryEntry;
  outfile: file of byte;
  reportfile: textfile;    

  fatChain:array[0..2097151] of longInt;
  lastFileSizeBytes:Integer;
  sect:DiskSector;

implementation

{$R *.DFM}


//Standard SPI player EEPROM image (compiled with vskit133 from sp_spi.c)
Const sp_spi : Array [0..811] of byte = (
     $56,  $4C,  $53,  $49,  $00,  $14,  $03,  $50,  $00,  $96,  $00,  $06,  $00,  $40,  $41,  $00,
     $28,  $88,  $B9,  $11,  $00,  $24,  $00,  $13,  $36,  $15,  $B8,  $22,  $3E,  $14,  $B8,  $05,
     $3E,  $24,  $00,  $15,  $36,  $0A,  $80,  $00,  $00,  $01,  $38,  $10,  $3E,  $C0,  $0B,  $00,
     $00,  $C1,  $07,  $00,  $00,  $11,  $38,  $14,  $3E,  $10,  $1A,  $30,  $00,  $11,  $E8,  $07,
     $00,  $24,  $80,  $04,  $3E,  $52,  $04,  $30,  $00,  $00,  $21,  $80,  $B8,  $24,  $00,  $D0,
     $38,  $24,  $00,  $00,  $31,  $24,  $00,  $90,  $40,  $24,  $00,  $00,  $40,  $24,  $00,  $00,
     $40,  $24,  $00,  $00,  $38,  $24,  $00,  $00,  $32,  $24,  $00,  $12,  $C0,  $24,  $40,  $00,
     $3A,  $24,  $80,  $F4,  $36,  $11,  $18,  $F4,  $36,  $01,  $18,  $F0,  $36,  $14,  $90,  $05,
     $34,  $24,  $00,  $E3,  $36,  $00,  $00,  $00,  $20,  $15,  $98,  $F2,  $36,  $24,  $00,  $13,
     $36,  $17,  $B8,  $12,  $3E,  $15,  $38,  $12,  $3E,  $14,  $B8,  $05,  $3E,  $24,  $00,  $15,
     $36,  $10,  $38,  $10,  $3E,  $C0,  $0B,  $00,  $00,  $10,  $1A,  $30,  $00,  $4C,  $13,  $00,
     $38,  $80,  $0B,  $00,  $00,  $24,  $00,  $00,  $38,  $C0,  $D1,  $20,  $29,  $24,  $00,  $30,
     $34,  $C0,  $0B,  $00,  $00,  $10,  $18,  $00,  $38,  $24,  $00,  $F0,  $36,  $14,  $90,  $05,
     $34,  $24,  $00,  $F3,  $36,  $15,  $18,  $F2,  $36,  $00,  $00,  $00,  $20,  $17,  $98,  $F2,
     $36,  $C0,  $0B,  $00,  $00,  $24,  $00,  $13,  $36,  $17,  $B8,  $12,  $3E,  $15,  $38,  $12,
     $3E,  $14,  $B8,  $05,  $3E,  $24,  $00,  $25,  $36,  $0A,  $80,  $00,  $00,  $10,  $78,  $10,
     $3E,  $10,  $1A,  $30,  $00,  $24,  $00,  $00,  $38,  $80,  $0B,  $00,  $00,  $24,  $00,  $00,
     $38,  $C0,  $D1,  $20,  $29,  $40,  $01,  $00,  $00,  $C0,  $D1,  $20,  $29,  $4C,  $18,  $80,
     $B8,  $4C,  $10,  $92,  $68,  $C0,  $33,  $10,  $B0,  $10,  $1A,  $30,  $00,  $15,  $25,  $00,
     $28,  $C0,  $0B,  $00,  $00,  $4C,  $10,  $00,  $38,  $10,  $18,  $F0,  $34,  $24,  $40,  $F0,
     $36,  $14,  $90,  $05,  $34,  $24,  $00,  $F3,  $36,  $15,  $18,  $F2,  $36,  $00,  $00,  $00,
     $20,  $17,  $98,  $F2,  $36,  $24,  $00,  $13,  $36,  $17,  $B8,  $12,  $3E,  $15,  $38,  $12,
     $3E,  $14,  $B8,  $05,  $3E,  $24,  $00,  $25,  $36,  $0A,  $80,  $00,  $00,  $10,  $78,  $10,
     $3E,  $01,  $80,  $00,  $00,  $0E,  $F8,  $13,  $3E,  $10,  $1A,  $30,  $00,  $80,  $21,  $00,
     $29,  $24,  $40,  $03,  $3E,  $80,  $0B,  $00,  $00,  $4C,  $18,  $00,  $38,  $C0,  $D1,  $20,
     $29,  $C0,  $00,  $00,  $00,  $4C,  $18,  $D3,  $34,  $24,  $00,  $30,  $34,  $24,  $00,  $82,
     $FF,  $24,  $00,  $B2,  $48,  $C0,  $D1,  $20,  $29,  $24,  $00,  $80,  $41,  $C1,  $3F,  $00,
     $00,  $4C,  $18,  $D3,  $34,  $24,  $00,  $30,  $34,  $24,  $00,  $00,  $40,  $C0,  $D1,  $20,
     $29,  $24,  $00,  $10,  $B0,  $C0,  $D1,  $20,  $29,  $4C,  $18,  $80,  $B8,  $CE,  $3F,  $00,
     $00,  $80,  $0F,  $00,  $00,  $CE,  $32,  $00,  $24,  $24,  $00,  $00,  $38,  $4C,  $18,  $80,
     $B8,  $C0,  $D1,  $20,  $29,  $0C,  $13,  $09,  $30,  $10,  $45,  $00,  $F4,  $24,  $C0,  $45,
     $34,  $24,  $00,  $10,  $3F,  $24,  $C0,  $05,  $38,  $10,  $1A,  $30,  $00,  $00,  $40,  $00,
     $00,  $24,  $00,  $13,  $34,  $24,  $00,  $F0,  $3C,  $C0,  $0B,  $00,  $00,  $00,  $20,  $80,
     $B8,  $24,  $40,  $F3,  $36,  $0E,  $D8,  $F3,  $36,  $10,  $58,  $F0,  $36,  $14,  $90,  $05,
     $34,  $24,  $00,  $F3,  $36,  $15,  $18,  $F2,  $36,  $00,  $00,  $00,  $20,  $17,  $98,  $F2,
     $36,  $17,  $B8,  $12,  $3E,  $15,  $38,  $12,  $3E,  $14,  $B8,  $05,  $3E,  $24,  $00,  $15,
     $36,  $0A,  $80,  $00,  $00,  $03,  $B8,  $10,  $3E,  $03,  $00,  $04,  $00,  $12,  $78,  $14,
     $3E,  $11,  $10,  $30,  $00,  $52,  $04,  $30,  $00,  $24,  $C0,  $14,  $3E,  $53,  $E8,  $07,
     $00,  $40,  $B8,  $00,  $31,  $24,  $00,  $36,  $C2,  $24,  $C0,  $10,  $39,  $03,  $00,  $04,
     $00,  $24,  $80,  $00,  $31,  $24,  $00,  $36,  $C2,  $24,  $C0,  $00,  $39,  $C3,  $07,  $00,
     $00,  $24,  $80,  $00,  $32,  $02,  $0C,  $36,  $C2,  $03,  $28,  $86,  $B3,  $50,  $38,  $C6,
     $4D,  $C3,  $FF,  $3B,  $00,  $C0,  $28,  $00,  $29,  $24,  $80,  $00,  $3E,  $CC,  $07,  $D3,
     $36,  $02,  $04,  $80,  $B8,  $24,  $00,  $36,  $B2,  $24,  $C0,  $10,  $39,  $C3,  $FF,  $3B,
     $00,  $24,  $80,  $00,  $31,  $24,  $00,  $36,  $B2,  $24,  $C0,  $00,  $39,  $24,  $C0,  $F4,
     $36,  $12,  $58,  $F4,  $36,  $03,  $98,  $F0,  $36,  $14,  $90,  $05,  $34,  $24,  $00,  $F3,
     $36,  $15,  $18,  $F2,  $36,  $00,  $00,  $00,  $20,  $17,  $98,  $F2,  $36,  $24,  $00,  $13,
     $36,  $17,  $B8,  $12,  $3E,  $15,  $38,  $12,  $3E,  $14,  $B8,  $05,  $3E,  $24,  $00,  $15,
     $36,  $C0,  $14,  $00,  $29,  $10,  $38,  $00,  $3E,  $10,  $03,  $00,  $00,  $00,  $24,  $10,
     $29,  $80,  $36,  $00,  $00,  $10,  $18,  $F0,  $36,  $14,  $90,  $05,  $34,  $24,  $00,  $F3,
     $36,  $15,  $18,  $F2,  $36,  $00,  $00,  $00,  $20,  $17,  $98,  $F2,  $36,  $01,  $04,  $00,
     $A0,  $1F,  $02,  $00,  $20,  $00,  $03,  $00,  $00,  $50,  $00,  $00);



// Standard preprogrammed Nand Flash player software: Nandfirmware with mapperless + minimal options
Const sp_nand : Array [0..1409] of byte = (
     $56,  $4C,  $53,  $49,  $00,  $01,  $08,  $12,  $00,  $32,  $00,  $03,  $42,  $6F,  $4F,  $74,
     $80,  $00,  $02,  $93,  $00,  $50,  $2A,  $00,  $34,  $00,  $20,  $00,  $00,  $00,  $00,  $10,
     $5B,  $00,  $36,  $13,  $00,  $24,  $3E,  $12,  $B8,  $17,  $3E,  $12,  $38,  $15,  $3E,  $05,
     $B8,  $14,  $36,  $15,  $00,  $24,  $00,  $00,  $80,  $0A,  $3E,  $10,  $38,  $01,  $3E,  $10,
     $B8,  $04,  $3E,  $11,  $78,  $10,  $00,  $06,  $AC,  $90,  $3E,  $04,  $78,  $12,  $30,  $09,
     $00,  $00,  $40,  $80,  $00,  $24,  $00,  $00,  $00,  $04,  $28,  $00,  $1F,  $85,  $B8,  $80,
     $00,  $24,  $00,  $06,  $91,  $11,  $29,  $10,  $EA,  $C0,  $30,  $09,  $20,  $00,  $31,  $00,
     $00,  $24,  $40,  $80,  $00,  $24,  $00,  $00,  $01,  $02,  $28,  $00,  $1C,  $85,  $00,  $00,
     $01,  $81,  $00,  $06,  $AC,  $52,  $30,  $09,  $08,  $00,  $B0,  $10,  $00,  $24,  $00,  $00,
     $00,  $24,  $28,  $00,  $1C,  $85,  $00,  $00,  $00,  $24,  $00,  $00,  $00,  $02,  $31,  $13,
     $00,  $24,  $31,  $00,  $00,  $24,  $40,  $80,  $00,  $24,  $00,  $3F,  $FC,  $C1,  $28,  $00,
     $1E,  $85,  $00,  $30,  $14,  $52,  $00,  $00,  $02,  $00,  $D2,  $04,  $00,  $24,  $32,  $00,
     $00,  $24,  $B0,  $10,  $00,  $24,  $C0,  $20,  $00,  $24,  $3A,  $00,  $00,  $24,  $36,  $F4,
     $58,  $12,  $36,  $F1,  $58,  $10,  $36,  $F0,  $98,  $04,  $36,  $F0,  $18,  $01,  $34,  $05,
     $90,  $14,  $36,  $F3,  $00,  $24,  $36,  $F2,  $18,  $15,  $20,  $00,  $00,  $00,  $36,  $F2,
     $98,  $17,  $3E,  $12,  $B8,  $17,  $3E,  $12,  $38,  $15,  $3E,  $05,  $B8,  $14,  $36,  $35,
     $00,  $24,  $00,  $00,  $80,  $0A,  $3E,  $10,  $B8,  $03,  $3E,  $11,  $38,  $05,  $00,  $00,
     $00,  $84,  $3E,  $11,  $B8,  $07,  $3E,  $14,  $78,  $12,  $00,  $06,  $93,  $D2,  $3E,  $04,
     $D0,  $4C,  $B8,  $84,  $08,  $11,  $31,  $23,  $00,  $24,  $31,  $01,  $40,  $24,  $FF,  $4A,
     $00,  $24,  $4C,  $BA,  $00,  $24,  $30,  $09,  $30,  $44,  $30,  $09,  $33,  $C5,  $28,  $00,
     $2C,  $40,  $3C,  $F0,  $80,  $24,  $00,  $07,  $EF,  $46,  $30,  $09,  $10,  $44,  $30,  $09,
     $13,  $C5,  $34,  $01,  $C0,  $24,  $46,  $7C,  $00,  $24,  $46,  $7C,  $00,  $24,  $F4,  $00,
     $41,  $95,  $35,  $10,  $80,  $24,  $35,  $F0,  $C0,  $24,  $6E,  $DE,  $00,  $24,  $00,  $06,
     $93,  $D2,  $28,  $00,  $2E,  $11,  $00,  $00,  $00,  $24,  $B3,  $86,  $45,  $13,  $32,  $04,
     $4C,  $46,  $31,  $23,  $0F,  $C7,  $31,  $00,  $93,  $CC,  $4F,  $D6,  $9B,  $CC,  $33,  $00,
     $AC,  $42,  $62,  $94,  $AF,  $C3,  $3B,  $00,  $80,  $24,  $00,  $07,  $EF,  $11,  $31,  $00,
     $D0,  $4C,  $34,  $00,  $98,  $4C,  $62,  $38,  $00,  $24,  $00,  $06,  $93,  $D1,  $28,  $00,
     $27,  $08,  $00,  $00,  $00,  $24,  $B8,  $80,  $B8,  $40,  $30,  $09,  $10,  $42,  $3E,  $10,
     $13,  $83,  $68,  $90,  $38,  $50,  $3E,  $10,  $00,  $24,  $3E,  $10,  $80,  $24,  $3E,  $10,
     $C0,  $24,  $31,  $00,  $00,  $24,  $F4,  $00,  $40,  $12,  $3E,  $00,  $09,  $8C,  $32,  $02,
     $00,  $24,  $20,  $00,  $00,  $00,  $00,  $00,  $31,  $48,  $36,  $93,  $00,  $24,  $36,  $F4,
     $C0,  $24,  $36,  $F4,  $58,  $12,  $36,  $F1,  $98,  $07,  $36,  $F1,  $18,  $05,  $36,  $F0,
     $98,  $03,  $34,  $05,  $90,  $14,  $36,  $F3,  $00,  $24,  $36,  $F2,  $18,  $15,  $20,  $00,
     $00,  $00,  $36,  $F2,  $98,  $17,  $00,  $07,  $EF,  $11,  $00,  $06,  $91,  $90,  $00,  $00,
     $02,  $80,  $36,  $13,  $00,  $24,  $3E,  $05,  $B8,  $14,  $36,  $15,  $00,  $24,  $00,  $00,
     $80,  $0A,  $B8,  $80,  $20,  $00,  $28,  $00,  $42,  $80,  $68,  $98,  $24,  $00,  $36,  $13,
     $00,  $24,  $B8,  $80,  $38,  $40,  $3E,  $10,  $00,  $24,  $00,  $00,  $00,  $80,  $3E,  $10,
     $00,  $24,  $31,  $04,  $00,  $24,  $30,  $23,  $00,  $24,  $30,  $40,  $80,  $24,  $FF,  $A8,
     $00,  $24,  $48,  $B6,  $00,  $24,  $3E,  $10,  $80,  $24,  $3E,  $10,  $C0,  $24,  $31,  $00,
     $00,  $24,  $3E,  $00,  $00,  $24,  $30,  $02,  $00,  $24,  $20,  $00,  $00,  $00,  $00,  $00,
     $3A,  $C8,  $00,  $00,  $3F,  $C1,  $00,  $06,  $9F,  $90,  $30,  $70,  $1A,  $8C,  $B0,  $10,
     $00,  $4C,  $60,  $14,  $00,  $00,  $00,  $07,  $EF,  $42,  $28,  $00,  $3E,  $15,  $B0,  $10,
     $00,  $24,  $60,  $14,  $00,  $24,  $00,  $00,  $00,  $24,  $28,  $00,  $42,  $45,  $00,  $00,
     $00,  $24,  $00,  $07,  $EF,  $42,  $00,  $07,  $EF,  $12,  $31,  $04,  $00,  $24,  $32,  $00,
     $C0,  $8C,  $63,  $96,  $00,  $00,  $FF,  $88,  $28,  $03,  $43,  $96,  $00,  $24,  $42,  $34,
     $00,  $24,  $42,  $34,  $00,  $24,  $48,  $B2,  $40,  $95,  $3D,  $10,  $00,  $24,  $3D,  $F0,
     $40,  $24,  $00,  $00,  $04,  $01,  $32,  $00,  $00,  $24,  $60,  $12,  $00,  $24,  $00,  $00,
     $03,  $10,  $28,  $00,  $44,  $C5,  $00,  $30,  $04,  $51,  $64,  $98,  $00,  $24,  $00,  $06,
     $93,  $D1,  $31,  $04,  $00,  $24,  $30,  $33,  $00,  $24,  $30,  $00,  $00,  $24,  $64,  $02,
     $00,  $24,  $00,  $06,  $9F,  $00,  $28,  $00,  $36,  $91,  $00,  $00,  $03,  $10,  $00,  $30,
     $04,  $51,  $00,  $06,  $93,  $13,  $00,  $06,  $91,  $D2,  $00,  $00,  $03,  $01,  $29,  $10,
     $24,  $00,  $00,  $00,  $21,  $C0,  $00,  $30,  $14,  $50,  $30,  $00,  $00,  $24,  $C0,  $12,
     $00,  $24,  $38,  $F0,  $40,  $24,  $00,  $00,  $03,  $01,  $30,  $00,  $00,  $24,  $C0,  $12,
     $00,  $24,  $38,  $00,  $40,  $24,  $00,  $06,  $93,  $50,  $00,  $3F,  $FC,  $C1,  $31,  $00,
     $00,  $24,  $B0,  $12,  $00,  $24,  $00,  $3F,  $FA,  $00,  $39,  $00,  $40,  $24,  $B8,  $80,
     $2B,  $40,  $3A,  $00,  $00,  $24,  $00,  $00,  $40,  $00,  $3B,  $00,  $00,  $24,  $00,  $20,
     $00,  $40,  $29,  $10,  $41,  $40,  $38,  $00,  $00,  $24,  $29,  $00,  $00,  $80,  $36,  $13,
     $00,  $24,  $40,  $80,  $00,  $24,  $00,  $06,  $93,  $90,  $28,  $00,  $62,  $15,  $00,  $00,
     $00,  $24,  $00,  $06,  $90,  $12,  $00,  $3F,  $FF,  $C4,  $00,  $06,  $A2,  $51,  $30,  $00,
     $18,  $4C,  $29,  $00,  $01,  $00,  $30,  $09,  $24,  $00,  $40,  $80,  $28,  $00,  $00,  $00,
     $00,  $24,  $28,  $00,  $62,  $05,  $00,  $00,  $00,  $24,  $68,  $90,  $08,  $CC,  $B8,  $80,
     $2B,  $C0,  $3A,  $00,  $00,  $24,  $00,  $06,  $91,  $50,  $30,  $D0,  $18,  $4C,  $40,  $80,
     $00,  $24,  $00,  $00,  $00,  $24,  $28,  $00,  $56,  $05,  $00,  $00,  $00,  $24,  $00,  $06,
     $90,  $10,  $29,  $11,  $F8,  $80,  $30,  $09,  $38,  $00,  $40,  $84,  $00,  $00,  $29,  $12, 
     $00,  $C0,  $30,  $09,  $1B,  $CC,  $00,  $06,  $90,  $50,  $41,  $88,  $03,  $C0,  $61,  $02, 
     $00,  $00,  $00,  $06,  $90,  $10,  $28,  $00,  $55,  $55,  $40,  $90,  $98,  $4C,  $00,  $00, 
     $00,  $24,  $28,  $00,  $51,  $D9,  $00,  $00,  $00,  $24,  $00,  $06,  $90,  $50,  $28,  $00, 
     $56,  $80,  $38,  $01,  $1B,  $CC,  $30,  $F0,  $1B,  $CC,  $38,  $00,  $00,  $24,  $30,  $00, 
     $00,  $24,  $40,  $80,  $00,  $24,  $00,  $00,  $00,  $24,  $28,  $00,  $59,  $18,  $00,  $00, 
     $00,  $24,  $00,  $06,  $90,  $51,  $31,  $00,  $43,  $CC,  $30,  $00,  $00,  $24,  $41,  $00,
     $00,  $24,  $39,  $00,  $00,  $24,  $00,  $06,  $90,  $10,  $30,  $10,  $58,  $4C,  $60,  $14, 
     $00,  $00,  $00,  $00,  $00,  $24,  $28,  $00,  $5B,  $C8,  $00,  $00,  $00,  $24,  $00,  $06,
     $90,  $51,  $31,  $00,  $00,  $24,  $60,  $12,  $00,  $24,  $39,  $00,  $40,  $24,  $30,  $00, 
     $00,  $24,  $60,  $90,  $00,  $44,  $29,  $00,  $01,  $00,  $38,  $F0,  $00,  $24,  $40,  $80, 
     $00,  $4C,  $00,  $00,  $00,  $00,  $28,  $00,  $61,  $98,  $00,  $00,  $00,  $24,  $00,  $06, 
     $9D,  $D2,  $00,  $06,  $97,  $D1,  $00,  $06,  $9D,  $93,  $30,  $73,  $0B,  $C1,  $38,  $00, 
     $00,  $24,  $39,  $F0,  $00,  $24,  $00,  $3F,  $FF,  $C0,  $39,  $E0,  $08,  $00,  $39,  $10, 
     $00,  $24,  $39,  $D0,  $40,  $24,  $68,  $90,  $24,  $40,  $39,  $F0,  $40,  $24,  $29,  $00, 
     $07,  $00,  $3B,  $00,  $00,  $24,  $28,  $00,  $50,  $00,  $40,  $88,  $00,  $24,  $28,  $00, 
     $50,  $00,  $38,  $00,  $00,  $24,  $00,  $06,  $80,  $10,  $00,  $06,  $94,  $81,  $00,  $00, 
     $08,  $00,  $36,  $13,  $00,  $24,  $3E,  $10,  $00,  $24,  $00,  $00,  $10,  $00,  $29,  $00, 
     $0C,  $80,  $3E,  $00,  $40,  $24,  $29,  $11,  $F5,  $80,  $B8,  $82,  $1B,  $8C,  $00,  $06, 
     $80,  $01,  $00,  $00,  $08,  $00,  $36,  $13,  $00,  $24,  $3E,  $10,  $00,  $24,  $29,  $20, 
     $36,  $00,  $3E,  $10,  $40,  $24,  $28,  $00,  $4B,  $40,  $36,  $E3,  $00,  $24,  $80,  $01, 
     $00,  $1B,  $1F,  $A0,  $01,  $00,  $00,  $0B,  $81,  $00,  $00,  $0C,  $00,  $01,  $00,  $06, 
     $80,  $01,  $00,  $06,  $00,  $02,  $00,  $05,  $80,  $02,  $00,  $05,  $00,  $04,  $00,  $01, 
     $80,  $04,  $00,  $03,  $00,  $08,  $00,  $02,  $80,  $08,  $00,  $0D,  $C0,  $00,  $00,  $0F, 
     $00,  $10,  $00,  $07,  $80,  $10,  $80,  $0A,  $00,  $00,  $00,  $00,  $80,  $03,  $00,  $00, 
     $00,  $50);






function WillBeFileName(thisFile:string; j:Integer):String;
var s,Name,Ext:string;
begin
  Name:='        '; Ext:='   ';
  s := ExtractFileName(thisFile)+'______';
  Name[1]:=UpCase(s[1]);
  Name[2]:=UpCase(s[2]);
  Name[3]:=UpCase(s[3]);
  Name[4]:=UpCase(s[4]);
  Name[5]:=UpCase(s[5]);
  Name[8]:=chr(ord('0') + j mod 10);
  j := j div 10;
  Name[7]:=chr(ord('0') + j mod 10);
  j := j div 10;
  Name[6]:=chr(ord('0') + j mod 10);
  j := j div 10;
//  Name[5]:=chr(ord('0') + j mod 10);
//  j := j div 10;


  for j:=1 to 8 do if name[j]='.' then name[j]:='_';
  for j:=1 to 8 do if name[j]=' ' then name[j]:='_';
  s := ExtractFileExt(thisFile)+#0+#0+#0;
  Ext[1]:=UpCase(s[2]);
  Ext[2]:=UpCase(s[3]);
  Ext[3]:=UpCase(s[4]);
  s:=Name+'.'+Ext;
  result := s;
end;




procedure SetColorArea(c:TColor;xstart,xend:Double);
begin
with form1.Image1.Canvas do begin
     Brush.Color := c;
     FillRect(rect(trunc(Form1.Image1.Width*xstart),0,round((Form1.Image1.Width*xend)+0.5),Form1.Image1.Height));
end;
end;


procedure CalculateFree;
begin
     img.freeSectors := img.totalSectors-img.reservedSectorsAtEnd-img.nextFreeSector;
     Form1.LFree.Caption := 'Free Space: '+inttostr(img.freeSectors)+' sectors ('+floattostrf(img.freeSectors/2048,ffFixed,7,2)+' MB)';
     Form1.fatSectors.Caption := 'FAT filesystem image is in sectors '+inttostr(img.diskStartSector)+'...'
     +inttostr(img.nextFreeSector-1)+' (address 0x'+IntToHex(img.diskStartSector*512,8)+'...0x'
     +inttohex((img.nextFreeSector-1)*512,8)+')';

end;

procedure CalculateSectors;
begin
with Form1 do begin
     img.dataBits := ComboBox1.ItemIndex;
     img.blockBits := ComboBox2.ItemIndex;
     img.totalSectors := 1 shl img.dataBits;
     img.blockSize := 1 shl img.blockBits;
     img.pageSize := 4;
     if ComboBox3.ItemIndex = 0 then img.pageSize := 1;

     img.totalPages := img.totalSectors div img.pageSize;
     img.totalBlocks := img.totalSectors div img.blockSize;

     //img.reservedBlocks := (img.totalBlocks div 100) + 2;
     img.reservedBlocksAtEnd := 0;
     img.reservedSectorsAtEnd := img.reservedBlocksAtEnd * img.blockSize;

     Lsectors.Caption := IntToStr (img.totalSectors);
     Lpages.Caption := IntToStr (img.totalPages);
     Lblocks.Caption := IntToStr (img.totalBlocks);

     //Lresblocks.Caption := IntToStr (img.reservedBlocksAtEnd);
     Lresblocks.Caption := '2 erasable blocks';

     img.diskStartSector := img.blockSize * 2;

     if img.diskStartSector < 32 then img.diskStartSector := 32;
     if Form1.Override16k.Checked then begin
        img.diskStartSector := StrToInt(Form1.ManualFatStartSector.Text);
     end;

     // BPB is here
     img.fatStartSector := img.diskStartSector + 1;
     img.fatSectors := (img.totalSectors+127) div 128;
     img.dataStartSector := img.fatStartSector+img.fatSectors;
     img.rootSectors := 1;
     img.rootSectors := (Form1.ListBox1.Count div 16) + 1;
     img.nextFreeSector := img.dataStartSector+img.rootSectors;

     SetColorArea ($efffef,0,1);
     SetColorArea (clBlack,1-(img.reservedBlocksAtEnd/img.totalBlocks),1);
     SetColorArea (clBlue,0,(img.nextFreeSector)/img.totalSectors);
     SetColorArea (clBlack,0,(img.diskStartSector)/img.totalSectors);

     CalculateFree;

     if img.pageSize = 4 then begin
        img.nandType := 1;
        if img.dataBits > 18 then img.nandType := 3;
     end else begin
        img.nandType := 0;
        if img.dataBits > 16 then img.nandType := 2;
     end;


end;
end;




procedure ClearDir;
var pb : ^byte;
    i: Integer;
begin
     pb := addr(dir);
     for i:=0 to sizeof(dir)-1 do begin
         pb^ := 0;
         inc(pb);
     end;
end;

function ScanFile(fileName:string):Integer;
var fi:file of byte;
    sect:Array[0..16383] of byte;
    n,d:Integer;
    sectors:Integer;
begin
     sectors := 0;
     if FileExists(fileName) then begin
      AssignFile(fi,fileName);
      Reset(fi);
      lastFileSizeBytes := fileSize(fi);
      while (not eof(fi)) do begin
            inc(sectors);
            BlockRead(fi,sect,512,n);
            for n:=n to 511 do sect[n] := $ff;
      end;
      CloseFile(fi);
     end;
     Result := sectors;
end;


function AddFileToImageList(FileName:String):Boolean;
var size:integer;
begin
  Result := True;
  with Form1 do begin
     size :=  ScanFile(FileName);
     if (size <= img.freeSectors) then begin

        ListBox1.Items.Add(FileName+' --> will be '+WillBeFileName(FileName,ListBox1.Items.Count + 1));
        inc (img.nextFreeSector,size);
        CalculateFree;
        SetColorArea (clGreen,img.dataStartSector/img.totalSectors, img.nextFreeSector/img.totalSectors);
        Form1.Repaint;        
     end else begin
         ShowMessage('Not enough space on device');
         Result := False;
     end;
     Label12.Caption := '';
     Label13.Caption := '';
  end;
end;



procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
     ComboBox1.ItemIndex := 20;
     ComboBox2.ItemIndex := 8;
     ComboBox3.ItemIndex := 1;
     CalculateSectors;
end;

procedure TForm1.isNandClick(Sender: TObject);
begin
  if isNand.Checked then ComboBox3.Enabled := True;
end;

procedure TForm1.isSPIClick(Sender: TObject);
begin
  if isSpi.Checked then begin
    ComboBox3.Enabled := False;
    ComboBox3.ItemIndex := 0;
  end;

end;

procedure TForm1.Override16kClick(Sender: TObject);
begin
  CalculateSectors;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
     CalculateSectors;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
     CalculateSectors;
     //DeviceName.Text := '';

end;

procedure TForm1.ComboBox3Change(Sender: TObject);
begin
     CalculateSectors;
     //DeviceName.Text := '';

end;



procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
     FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  ShowMessage(#13'VS1000B Pre-Programmed Player Image Generator'
    +#13#13'This software makes a binary image, that contains the boot code and Ogg Vorbis files,'
    +#13'which can be preprogrammed to a nand flash or an SPI flash/eeprom'
    +#13'before soldering using a memory programmer.'
    +#13#13'Prommer24.c can be used to program a 128K...16MB SPI flash using'
    +#13'a VS1000B Developer Board (use "build prommer24" in vskit133).'
    +#13'Similarly, the latest nandprog.c can be used to prom nand flashes.'
    +#13#13'USB connectivity is impossible or limited with preprogrammed players.'
    +#13#13'Coded by Panu-Kristian Poiksalo, '
    +'Copyright (C) 2007 VLSI Solution Oy, Tampere Finland'
    +#13'For further information, please contact mp3@vlsi.fi'#13);
end;

procedure TForm1.AddAllClick(Sender: TObject);
var i:integer;
begin

  for i:=0 to Form1.FileListBox1.Items.Count - 1 do begin
    if not AddFileToImageList(Form1.DirectoryListBox1.Directory+'\'+Form1.FileListBox1.Items.Strings[i])
    then exit;
    Application.Title := inttostr(i)+' - Image Generator';
  end;
  Application.Title := 'Image Generator';
end;

procedure TForm1.bootSP_NANDClick(Sender: TObject);
begin
  if bootSP_NAND.Checked then isNand.Checked := True;

end;

procedure TForm1.bootSP_SPIClick(Sender: TObject);
begin
  if bootSP_SPI.checked then begin
    isSPI.Checked := True;
    ComboBox2.ItemIndex := 3;
    ComboBox1.ItemIndex := 15;
    CalculateSectors;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     DirectoryListBox1.Directory := 'C:\';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     DirectoryListBox1.Directory := 'D:\';

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     DirectoryListBox1.Directory := 'E:\';

end;


Procedure PutSector(p:pointer);
begin
     BlockWrite(outFile,p,512);
end;


function PutFile(fileName:string):Integer;
var fi:file of byte;
    sect:Array[0..511] of byte;
    n,d:Integer;
    sectors:Integer;
begin

     sectors := 0;
     if FileExists(fileName) then begin
      AssignFile(fi,fileName);
      Reset(fi);
      while (not eof(fi)) do begin
            inc(sectors);
            BlockRead(fi,sect,512,n);
            for n:=n to 511 do sect[n] := $ff;
            BlockWrite(outFile,sect,512);
      end;
      CloseFile(fi);
     end;
     Result := sectors;

end;

function ReadFile16K(fileName:string):Integer;
var fi:file of byte;
    n,d:Integer;
begin
     n := 0;
     if FileExists(fileName) then begin
      AssignFile(fi,fileName);
      Reset(fi);
      BlockRead(fi,sect,16384,n);
      for d:=n to 16383 do sect[d] := $ff;
      CloseFile(fi);
     end else ShowMessage('Can''t find boot code image file: '+filename);
     Result := n;
end;







{
procedure TForm1.FileListBox1DblClick(Sender: TObject);
var size:integer;
begin
     size :=  ScanFile(FileListBox1.FileName);
     if (size <= img.freeSectors) then begin

        ListBox1.Items.Add(FileListBox1.FileName+' --> will be '+WillBeFileName(FileListBox1.FileName,ListBox1.Items.Count + 1));
        inc (img.nextFreeSector,size);
        CalculateFree;
        SetColorArea (clGreen,img.dataStartSector/img.totalSectors, img.nextFreeSector/img.totalSectors);
     end else begin
         ShowMessage('Not enough space on device');
     end;
     Label12.Caption := '';
     Label13.Caption := '';

end;
}

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
  AddFileToImageList(FileListBox1.FileName);
end;



procedure TForm1.FileListBox1Change(Sender: TObject);
var size:integer;
begin
     if FileListBox1.Filename <> '' then Label12.Caption := FileListBox1.FileName;
     size := ScanFile(FileListBox1.FileName);
     if size>0 then begin
        Label13.Caption := 'Size: '+floattostrf(size/2048,ffFixed,7,1)+'M ('
        +inttostr(size)+' sectors)';

        if size<=img.freeSectors then Label13.Caption := Label13.Caption + ' (fits to device)'
        else Label13.Caption := Label13.Caption + ' (does not fit to device)'

     end else Label13.caption := '';
end;


procedure TForm1.ClearImageClick(Sender: TObject);
begin
     ListBox1.Clear;
     CalculateSectors;
end;


function SectorToCluster(sector:integer):integer;
begin
     result := sector-img.dataStartSector + 2;
end;

function ClusterToSector(cluster:integer):integer;
begin
     result := cluster+img.dataStartSector - 2;
end;


procedure FatSetSector(currentSect,nextSect:integer);
var currentCluster, nextCluster:Integer;
begin
     currentCluster := SectorToCluster(currentSect);
     nextCluster := SectorToCluster(nextSect);
     if nextSect > -1 then fatChain[currentCluster]:=nextCluster
     else fatChain[currentCluster] := -1;
end;

procedure AdvanceFatChain;
begin
     FatSetSector(img.nextFreeSector,img.nextFreeSector+1);
     inc(img.nextFreeSector);
end;

procedure CloseFatChain;
begin
     FatSetSector(img.nextFreeSector,-1);
     inc(img.nextFreeSector);
end;

procedure PrintPos;
begin
end;


procedure Put32(index,data:integer);
begin
     sect[index] := data and $ff;
     sect[index+1] := (data shr 8) and $ff;
     sect[index+2] := (data shr 16) and $ff;
     sect[index+3] := (data shr 24) and $ff;
end;
procedure Put16(index,data:integer);
begin
     sect[index] := data and $ff;
     sect[index+1] := (data shr 8) and $ff;
end;


procedure ExportImageFile(filename:string);
var
    i, j, size, Entries:Integer;
    s, thisFile, newName : string;

begin
with Form1 do begin

     assignfile(reportfile,filename+'.report.txt');
     rewrite(reportfile);
     Writeln(reportFile,'Starting VS1000 Image Creation at '+datetimetostr(Now));
     writeln(reportfile,'Creating image '+filename);
     writeln(reportfile,'Nominal Size: '+ComboBox1.Text);
     writeln(reportfile,'Erasable Block Size: '+ComboBox2.Text);
     writeln(reportfile,'Page Size: '+ComboBox3.Text);
     writeln(reportfile,'Bus access time (ns): '+eNandTime.Text);
     if Form1.bootFile.Checked then writeln(reportfile,'Firmware: '+form1.imgfilename.Text);


     Entries := ListBox1.Items.Count;

     CalculateSectors;
     img.rootSectors := (Entries div 16) + 1;
     img.nextFreeSector := img.dataStartSector;
     fatChain[0]:=-1;
     fatChain[1]:=-1;

     writeln(reportfile,'Nand type: ',img.nandType);
     writeln(reportfile,'Disk Start Sector: ',img.diskStartSector);
     writeln(reportfile,'FAT Start Sector: ',img.fatStartSector);
     writeln(reportfile,'FAT Sectors: ',img.fatSectors);
     writeln(reportfile,'Root Start Sector: ',img.fatStartSector+img.fatSectors);
     writeln(reportfile,'Root Sectors: ',img.rootSectors);
     writeln(reportfile,'Data Start Sector: ',img.fatStartSector+img.fatSectors+img.rootSectors);

     writeln(reportfile);
     writeln(reportfile,'Files:');


     // Create Root Directory FAT chain
     for i:=1 to img.rootSectors-1 do AdvanceFatChain;
     CloseFatChain;

     // Create Root Directory Records
     for i:=0 to Entries-1 do begin
         thisFile := ListBox1.Items.Strings[i];
         thisfile := copy(thisfile,1,pos(' --> will be',thisfile)-1);
         size := scanFile(thisFile);
         j := i + 1;
         newName := WillBeFileName (thisFile, j);
          //form1.memo1.lines.add(newName);
         dir[i].Name[0]:=newName[1];
         dir[i].Name[1]:=newName[2];
         dir[i].Name[2]:=newName[3];
         dir[i].Name[3]:=newName[4];
         dir[i].Name[4]:=newName[5];
         dir[i].Name[5]:=newName[6];
         dir[i].Name[6]:=newName[7];
         dir[i].Name[7]:=newName[8];

         dir[i].Ext[0]:=newName[10];
         dir[i].Ext[1]:=newName[11];
         dir[i].Ext[2]:=newName[12];

         writeln(reportfile,newName+' : '+thisFile);


         {

         dir[i].Name[2]:=chr(ord('0') + j mod 10);
         j := j div 10;
         dir[i].Name[1]:=chr(ord('0') + j mod 10);
         j := j div 10;
         dir[i].Name[0]:=chr(ord('0') + j mod 10);
         j := j div 10;

         s := ExtractFileName(thisFile)+'______';
         dir[i].Name[3]:=upcase(s[1]);
         dir[i].Name[4]:=upcase(s[2]);
         dir[i].Name[5]:=upcase(s[3]);
         dir[i].Name[6]:=upcase(s[4]);
         dir[i].Name[7]:=upcase(s[5]);

         for j:=0 to 7 do if dir[i].name[j]='.' then dir[i].name[j]:='_';
         for j:=0 to 7 do if dir[i].name[j]=' ' then dir[i].name[j]:='_';

         s := ExtractFileExt(thisFile)+#0+#0+#0;
         dir[i].Ext[0]:=UpCase(s[2]);
         dir[i].Ext[1]:=UpCase(s[3]);
         dir[i].Ext[2]:=UpCase(s[4]);
         }


         dir[i].FileSize:=lastFileSizeBytes;

         j := SectorToCluster(img.nextFreeSector);
         dir[i].ClusterHi := j shr 16;
         dir[i].ClusterLo := j and $ffff;

         PrintPos;
         for j:=1 to size-1 do AdvanceFatChain;
         CloseFatChain;

     end;
     PrintPos;

     // Now FAT and Dir chains are completed, image can be written




     AssignFile(OutFile,FileName);
     ReWrite(outFile);

     // Start outputting image...
     for i:=0 to 16383 do sect[i] := $00;

     //read firmware image from disk

     //Option 1: Read a custom file from disk
     if bootFile.Checked then ReadFile16K (imgfilename.Text);

     //Option 2: Read starndard SPI player (sp_spi.img) from disk
     //no need to read from disk anymore, it's included in sp_spi[] array
     if bootSP_SPI.Checked then begin
      //ReadFile16K ('sp_spi.img');
      for i:=0 to 16383 do sect[i] := $ff;
      for I := 0 to sizeof(sp_spi) - 1 do sect[i] := sp_spi[i];

      if img.diskStartSector<>32 then ShowMessage('sp_spi.img expects that the FAT image starts at sector 32.'
      +' However, currently the FAT image starts at sector '+inttostr(img.diskStartSector)+' and the generated'
      +' img file will not work. If you have made modifications to the sp_spi.c and recompiled it,'
      +' select "Custom or self-compiled boot code" option from firmware options.'
      +#13#13'to use the standard sp_spi.c player image, set erasable block size to 8K or less, even if your'
      +' eeprom chip does not support such a block size. It does not matter since sp_spi does not write to the eeprom.');
     end;


     //Option 3: Use starndard NAND flash player (sp_spi.img)
     if bootSP_NAND.Checked then begin
      for i:=0 to 16383 do sect[i] := $ff;
      for I := 0 to sizeof(sp_nand) - 1 do sect[i] := sp_nand[i];
     end;


     //Done loading firmware.


     //for Nand Flash devices patch in the Nand Flash header
     if isNand.Checked then begin
       sect[0] := ord('V');
       sect[1] := ord('L');
       sect[2] := ord('S');
       sect[3] := ord('I');

       sect[5] := img.nandType;
       sect[6] := img.blockBits;
       sect[7] := img.dataBits;

       sect[8] := Hi(StrToInt(eNandTime.Text));
       sect[9] := Lo(StrToInt(eNandTime.Text));
     end;


     // Now put firmware

     j := img.diskStartSector;
     if j>32 then j:=32;

     BlockWrite (outFile,sect,j*512);

     for i:=0 to 512 do sect[i] := $ff;

     // Now put reserved area between firmware and FAT disk image //

     //j contains number of firmware blocks written
     for i:=j to img.diskStartSector-1 do BlockWrite(outFile,sect,512);

     // Disk Image Starts Here

     // Now put BPB //
     for i:=0 to 512 do sect[i] := 0;
     sect[0]  := $e9;
     sect[3]  := ord('M');
     sect[4]  := ord('S');
     sect[5]  := ord('W');
     sect[6]  := ord('I');
     sect[7]  := ord('N');
     sect[8]  := ord('4');
     sect[9]  := ord('.');
     sect[10] := ord('1');
     Put16(11,512); //512 bytes per sector
     sect[13] := 1; // 1 sector per cluster
     sect[14] := 1; // 1 reserved sector
     sect[16] := 1; // 1 FAT
     sect[21] := $ff; // Old Media Type

     Put32(32,img.totalSectors-img.diskStartSector); // TotSec32
     Put32(36,img.fatSectors); //one FAT size
     Put32(44,2); //Root starts at cluster 2

     sect[71] := ord('V');
     sect[72] := ord('L');
     sect[73] := ord('S');
     sect[74] := ord('I');
     sect[75] := ord('D');
     sect[76] := ord('I');
     sect[77] := ord('S');
     sect[78] := ord('K');
     sect[79] := ord('I');
     sect[80] := ord('M');
     sect[81] := ord('G');

     //This software always makes a FAT32 filesystem, regardless of size.
     //In VS1000 partition of any size can be FAT32 or FAT16.
     //FAT32 is simpler since cluster size can always be 512 bytes (1 sector)
     sect[82] := ord('F');
     sect[83] := ord('A');
     sect[84] := ord('T');
     sect[85] := ord('3');
     sect[86] := ord('2');
     sect[87] := ord(' ');
     sect[88] := ord(' ');
     sect[89] := ord(' ');

     sect[510] := $55;
     sect[511] := $aa;
     BlockWrite (outFile,sect,512);


     // Now put FAT //

     for i:=0 to img.fatSectors-1 do begin
         for j:=0 to 127 do begin
             Put32(j*4,fatChain[i*128+j]);
         end;
         BlockWrite (outFile,sect,512);
     end;


     // Now put ROOT //

     for i:=0 to img.rootSectors-1 do begin
         BlockWrite(outfile,dir[i*16],512);
     end;


     // Now put FILES //

     for i:=0 to Entries-1 do begin
         Application.Title := inttostr(i+1)+'/'+inttostr(Entries)+' - Image Generator';
         Form1.Label12.Caption := 'Adding file '+inttostr(i+1)+'/'+inttostr(Entries)+'  ';
         Form1.Repaint;
         thisFile := ListBox1.Items.Strings[i];
         thisfile := copy(thisfile,1,pos(' --> will be',thisfile)-1);
         size := PutFile(thisFile);
     end;

     // Image complete //

     CloseFile(outFile);
     Writeln(reportFile,'Creation finished at '+datetimetostr(Now));
     CloseFile(reportFile);

end;
end;


{
procedure TForm1.ExportImageClick(Sender: TObject);
begin
     if SaveDialog1.Execute then ExportImageFile (SaveDialog1.FileName);
     ListBox1.Clear;
end;
}

procedure MakeFileWithSpares (infilename:string);
var infile, outfile: file of byte;
  buf:array[0..2047] of byte;
  I, bs:integer;
begin
  Form1.Label12.Caption := 'Writing image with spares... ';
  Form1.Repaint;

  assignfile(infile,infilename);
  reset(infile);
  Form1.ListBox1.Items.Add(infilename);
  assignfile(outfile,infilename+'_with_spare.img');
  rewrite(outfile);
  //bs := img.pageSize * 512;  // Large Page does not work (I/O Error 6)
  bs := 512;
  while (not eof(infile)) do begin
    blockread (infile,buf,bs);
    blockwrite(outfile,buf,bs);
    for I := 0 to bs do buf[I] := $ff;
    //if bs=512 then
    blockwrite(outfile,buf,16);
    //else blockwrite(outfile,buf,bs);
  end;
  closefile(infile);
  closefile(outfile);

  Form1.Label12.Caption := '';

end;




procedure TForm1.ExportImageClick(Sender: TObject);
var fname:string;
begin
     if SaveDialog1.Execute then begin
      fname := SaveDialog1.FileName;
      ExportImageFile (fname);
      Application.Title := 'Spare creation - Image Generator';

      MakeFileWithSpares (fname);
      ListBox1.Clear;
      Application.Title := 'Image Generator';
     end;
end;




procedure TForm1.Button4Click(Sender: TObject);
begin
     if OpenDialog1.Execute then begin
        bootFile.checked := True;
        imgfilename.Text := OpenDialog1.FileName;

     end;
end;

end.
